import { __extends } from 'tslib';
import { Injectable, ɵɵdefineInjectable, ɵɵinject, Component, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoggerConfiguration = /** @class */ (function () {
    function LoggerConfiguration() {
    }
    return LoggerConfiguration;
}());
if (false) {
    /** @type {?} */
    LoggerConfiguration.prototype.isProduction;
    /** @type {?} */
    LoggerConfiguration.prototype.appPrefix;
}
;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var  /**
 * @abstract
 */
AbstractLoggerService = /** @class */ (function () {
    function AbstractLoggerService() {
    }
    return AbstractLoggerService;
}());
if (false) {
    /**
     * @abstract
     * @param {?} infoMessage
     * @return {?}
     */
    AbstractLoggerService.prototype.info = function (infoMessage) { };
    /**
     * @abstract
     * @param {?} warnMessage
     * @return {?}
     */
    AbstractLoggerService.prototype.warn = function (warnMessage) { };
    /**
     * @abstract
     * @param {?} errorMessage
     * @return {?}
     */
    AbstractLoggerService.prototype.error = function (errorMessage) { };
}
var AngularConsoleLoggerService = /** @class */ (function (_super) {
    __extends(AngularConsoleLoggerService, _super);
    function AngularConsoleLoggerService(loggerConfiguration) {
        var _this = _super.call(this) || this;
        _this.loggerConfiguration = loggerConfiguration;
        return _this;
    }
    /**
     * @param {?} infoMessage
     * @return {?}
     */
    AngularConsoleLoggerService.prototype.info = /**
     * @param {?} infoMessage
     * @return {?}
     */
    function (infoMessage) {
        if (!this.loggerConfiguration.isProduction) {
            console.log(this.loggerConfiguration.appPrefix + ": " + infoMessage);
        }
    };
    /**
     * @param {?} warnMessage
     * @return {?}
     */
    AngularConsoleLoggerService.prototype.warn = /**
     * @param {?} warnMessage
     * @return {?}
     */
    function (warnMessage) {
        if (!this.loggerConfiguration.isProduction) {
            console.warn(this.loggerConfiguration.appPrefix + ": " + warnMessage);
        }
    };
    /**
     * @param {?} errorMessage
     * @return {?}
     */
    AngularConsoleLoggerService.prototype.error = /**
     * @param {?} errorMessage
     * @return {?}
     */
    function (errorMessage) {
        if (!this.loggerConfiguration.isProduction) {
            console.error(this.loggerConfiguration.appPrefix + ": " + errorMessage);
        }
    };
    AngularConsoleLoggerService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AngularConsoleLoggerService.ctorParameters = function () { return [
        { type: LoggerConfiguration }
    ]; };
    /** @nocollapse */ AngularConsoleLoggerService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AngularConsoleLoggerService_Factory() { return new AngularConsoleLoggerService(ɵɵinject(LoggerConfiguration)); }, token: AngularConsoleLoggerService, providedIn: "root" });
    return AngularConsoleLoggerService;
}(AbstractLoggerService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    AngularConsoleLoggerService.prototype.loggerConfiguration;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularConsoleLoggerComponent = /** @class */ (function () {
    function AngularConsoleLoggerComponent() {
    }
    /**
     * @return {?}
     */
    AngularConsoleLoggerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    AngularConsoleLoggerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-angular-console-logger',
                    template: "\n    <p>\n      angular-console-logger works!\n    </p>\n  "
                }] }
    ];
    /** @nocollapse */
    AngularConsoleLoggerComponent.ctorParameters = function () { return []; };
    return AngularConsoleLoggerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularConsoleLoggerModule = /** @class */ (function () {
    function AngularConsoleLoggerModule() {
    }
    /**
     * @param {?} configuration
     * @return {?}
     */
    AngularConsoleLoggerModule.forRoot = /**
     * @param {?} configuration
     * @return {?}
     */
    function (configuration) {
        return {
            ngModule: AngularConsoleLoggerModule,
            providers: [{
                    provide: LoggerConfiguration,
                    useValue: configuration
                }]
        };
    };
    AngularConsoleLoggerModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [AngularConsoleLoggerComponent],
                    imports: [],
                    exports: [AngularConsoleLoggerComponent]
                },] }
    ];
    return AngularConsoleLoggerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AbstractLoggerService, AngularConsoleLoggerComponent, AngularConsoleLoggerModule, AngularConsoleLoggerService, LoggerConfiguration };
//# sourceMappingURL=cristianaleman-angular-console-logger.js.map
