import { Injectable, ɵɵdefineInjectable, ɵɵinject, Component, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LoggerConfiguration {
}
if (false) {
    /** @type {?} */
    LoggerConfiguration.prototype.isProduction;
    /** @type {?} */
    LoggerConfiguration.prototype.appPrefix;
}
;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class AbstractLoggerService {
}
if (false) {
    /**
     * @abstract
     * @param {?} infoMessage
     * @return {?}
     */
    AbstractLoggerService.prototype.info = function (infoMessage) { };
    /**
     * @abstract
     * @param {?} warnMessage
     * @return {?}
     */
    AbstractLoggerService.prototype.warn = function (warnMessage) { };
    /**
     * @abstract
     * @param {?} errorMessage
     * @return {?}
     */
    AbstractLoggerService.prototype.error = function (errorMessage) { };
}
class AngularConsoleLoggerService extends AbstractLoggerService {
    /**
     * @param {?} loggerConfiguration
     */
    constructor(loggerConfiguration) {
        super();
        this.loggerConfiguration = loggerConfiguration;
    }
    /**
     * @param {?} infoMessage
     * @return {?}
     */
    info(infoMessage) {
        if (!this.loggerConfiguration.isProduction) {
            console.log(`${this.loggerConfiguration.appPrefix}: ${infoMessage}`);
        }
    }
    /**
     * @param {?} warnMessage
     * @return {?}
     */
    warn(warnMessage) {
        if (!this.loggerConfiguration.isProduction) {
            console.warn(`${this.loggerConfiguration.appPrefix}: ${warnMessage}`);
        }
    }
    /**
     * @param {?} errorMessage
     * @return {?}
     */
    error(errorMessage) {
        if (!this.loggerConfiguration.isProduction) {
            console.error(`${this.loggerConfiguration.appPrefix}: ${errorMessage}`);
        }
    }
}
AngularConsoleLoggerService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AngularConsoleLoggerService.ctorParameters = () => [
    { type: LoggerConfiguration }
];
/** @nocollapse */ AngularConsoleLoggerService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AngularConsoleLoggerService_Factory() { return new AngularConsoleLoggerService(ɵɵinject(LoggerConfiguration)); }, token: AngularConsoleLoggerService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    AngularConsoleLoggerService.prototype.loggerConfiguration;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AngularConsoleLoggerComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
AngularConsoleLoggerComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-angular-console-logger',
                template: `
    <p>
      angular-console-logger works!
    </p>
  `
            }] }
];
/** @nocollapse */
AngularConsoleLoggerComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AngularConsoleLoggerModule {
    /**
     * @param {?} configuration
     * @return {?}
     */
    static forRoot(configuration) {
        return {
            ngModule: AngularConsoleLoggerModule,
            providers: [{
                    provide: LoggerConfiguration,
                    useValue: configuration
                }]
        };
    }
}
AngularConsoleLoggerModule.decorators = [
    { type: NgModule, args: [{
                declarations: [AngularConsoleLoggerComponent],
                imports: [],
                exports: [AngularConsoleLoggerComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AbstractLoggerService, AngularConsoleLoggerComponent, AngularConsoleLoggerModule, AngularConsoleLoggerService, LoggerConfiguration };
//# sourceMappingURL=cristianaleman-angular-console-logger.js.map
