import { LoggerConfiguration } from './logger.config';
export declare abstract class AbstractLoggerService {
    abstract info(infoMessage: string): any;
    abstract warn(warnMessage: string): any;
    abstract error(errorMessage: string): any;
}
export declare class AngularConsoleLoggerService extends AbstractLoggerService {
    private loggerConfiguration;
    constructor(loggerConfiguration: LoggerConfiguration);
    info(infoMessage: string): void;
    warn(warnMessage: string): void;
    error(errorMessage: string): void;
}
